package com.lucasjosino.on_audio_room.databases.favorites

import androidx.room.*

@Dao
interface OnFavoritesDao {
    //
    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun addToFavorites(entity: OnFavoritesEntity) : Long

    //
//    @Insert(onConflict = OnConflictStrategy.IGNORE)
//    suspend fun addToFavorites(favSong: OnFavoritesEntity) : Long

    //
    @Query("DELETE FROM on_favorites_db WHERE id = :songId")
    suspend fun deleteFromFavorites(songId: Long)

    //
    @Query("DELETE FROM on_favorites_db")
    suspend fun deleteAllFromFavorites()

    //
    @Query("SELECT EXISTS (SELECT 1 FROM on_favorites_db WHERE id = :songId)")
    suspend fun checkInFavorites(songId: Long) : Boolean

    //
    @Query("SELECT * FROM on_favorites_db WHERE id = :songId")
    suspend fun queryFromFavorites(songId: Long) : OnFavoritesEntity?

    //
    @Query("SELECT * FROM on_favorites_db LIMIT :QUERY_LIMIT")
    suspend fun queryAllFromFavorites(QUERY_LIMIT: Int) : List<OnFavoritesEntity>

    //
    @Query("SELECT id FROM on_favorites_db")
    suspend fun queryAllIdsFromFavorites() : List<Long>


    //
//    @Query("SELECT * FROM on_favorites_db")
//    fun queryAllFromFavoritesLive() : LiveData<List<OnSongEntity>>
}