package com.lucasjosino.on_audio_room.databases.lastPlayed

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query

@Dao
interface OnLastPlayedDao {

    //
    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun addToLastPlayed(entity: OnLastPlayedEntity) : Long

    //
    @Query("DELETE FROM on_lastPlayed_db WHERE id = :songId")
    suspend fun deleteFromLastPlayed(songId: Long)

    //
    @Query("DELETE FROM on_lastPlayed_db")
    suspend fun deleteAllFromLastPlayed()

    //
    @Query("SELECT EXISTS (SELECT 1 FROM on_lastPlayed_db WHERE id = :songId)")
    suspend fun checkInLastPlayed(songId: Long) : Boolean

    //
    @Query("SELECT * FROM on_lastPlayed_db WHERE id = :songId")
    suspend fun queryFromLastPlayed(songId: Long) : OnLastPlayedEntity?

    //
    @Query("SELECT * FROM on_lastPlayed_db ORDER BY timePlayed DESC LIMIT :QUERY_LIMIT")
    suspend fun queryAllFromLastPlayed(QUERY_LIMIT: Int) : List<OnLastPlayedEntity>

    //
    @Query("SELECT id FROM on_lastPlayed_db")
    suspend fun queryAllIdsFromLastPlayed() : List<Long>

    //
//    @Query("SELECT * FROM on_lastPlayed_db")
//    fun queryAllFromLastPlayedLive() : LiveData<List<OnLastPlayedEntity>>
}