package com.lucasjosino.on_audio_room.databases.mostPlayed

import androidx.room.*

@Dao
interface OnMostPlayedDao {
    //
    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun addToMostPlayed(entity: OnMostPlayedEntity) : Long

    //
    @Query("DELETE FROM on_mostPlayed_db WHERE id = :songId")
    suspend fun deleteFromMostPlayed(songId: Long)

    //
    @Query("DELETE FROM on_mostPlayed_db")
    suspend fun deleteAllFromMostPlayed()

    //
    @Update
    suspend fun updateMostPlayed(entity: OnMostPlayedEntity)

    //
    @Query("UPDATE on_mostPlayed_db SET count = count + 1 WHERE id = :songId")
    suspend fun updateMostPlayedCount(songId: Long)

    //
    @Query("SELECT EXISTS (SELECT 1 FROM on_mostPlayed_db WHERE id = :songId)")
    suspend fun checkInMostPlayed(songId: Long) : Boolean

    //
    @Query("SELECT * FROM on_mostPlayed_db WHERE id = :songId")
    suspend fun queryFromMostPlayed(songId: Long) : OnMostPlayedEntity?

    //
    @Query("SELECT * FROM on_mostPlayed_db ORDER BY count ASC LIMIT :QUERY_LIMIT")
    suspend fun queryAllFromMostPlayed(QUERY_LIMIT: Int) : List<OnMostPlayedEntity>

    //
    @Query("SELECT id FROM on_mostPlayed_db")
    suspend fun queryAllIdsFromMostPlayed() : List<Long>

    //
//    @Query("SELECT * FROM on_mostPlayed_db")
//    fun queryAllFromMostPlayedLive() : LiveData<List<OnMostPlayedEntity>>
}