package com.lucasjosino.on_audio_room.databases.playlists

import androidx.room.*

@Dao
interface OnPlaylistDao {
    //
    @Insert
    suspend fun createPlaylist(playlistEntity: OnPlaylistEntity) : Long

    //
    @Delete
    suspend fun deletePlaylist(playlistId: OnPlaylistEntity)

//    // TODO
//    @Delete
//    suspend fun deletePlaylists(playlistsEntity: List<OnPlaylistEntity>)

    //
    @Query("UPDATE on_playlists_db SET playlistName = :newName WHERE playlistId = :playlistId")
    suspend fun renamePlaylist(playlistId: Long, newName: String)

    //
    @Query("SELECT EXISTS (SELECT 1 FROM on_playlists_db WHERE playlistId = :playlistId)")
    suspend fun checkPlaylist(playlistId: Long) : Boolean

    //
    @Query("SELECT * FROM on_playlists_db WHERE playlistId = :playlistId")
    suspend fun queryPlaylist(playlistId: Long) : OnPlaylistEntity?

    //
    @Query("SELECT * FROM on_playlists_db LIMIT :QUERY_LIMIT")
    suspend fun queryAllPlaylist(QUERY_LIMIT: Int) : List<OnPlaylistEntity>

    //
    @Query("SELECT playlistId FROM on_playlists_db")
    suspend fun queryAllIdsFromPlaylist() : List<Long>

}