package com.lucasjosino.on_audio_room.databases.playlists.playlistSongs

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query

@Dao
interface OnPlaylistSongsDao {
    //
    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun addToPlaylist(entity: OnPlaylistSongsEntity) : Long

    //
    @Query("DELETE FROM on_playlistSongs_db WHERE playlistId = :playlistId")
    suspend fun deleteAllInPlaylist(playlistId: Long)

    //
    @Query("DELETE FROM on_playlistSongs_db WHERE playlistId = :playlistId AND id = :songId")
    suspend fun deleteFromPlaylist(playlistId: Long, songId: Long)

    //
    @Query("SELECT EXISTS (SELECT 1 FROM on_playlistSongs_db WHERE playlistId = :playlistId AND id = :songId)")
    suspend fun checkInPlaylist(playlistId: Long, songId: Long) : Boolean

    //
    @Query("SELECT * FROM on_playlistSongs_db WHERE playlistId = :playlistId AND id = :songId")
    suspend fun queryFromPlaylist(playlistId: Long, songId: Long) : OnPlaylistSongsEntity?

    //
    @Query("SELECT * FROM on_playlistSongs_db WHERE playlistId = :playlistId LIMIT :QUERY_LIMIT")
    suspend fun queryAllFromPlaylist(playlistId: Long, QUERY_LIMIT: Int) : List<OnPlaylistSongsEntity>

    //
    @Query("SELECT id FROM on_playlistSongs_db WHERE playlistId = :playlistId")
    suspend fun queryAllIdsFromPlaylistSongs(playlistId: Long) : List<Long>
}